Fapi_ExportKey
Feature API

## Functions

TSS2_RC | Fapi_ExportKey (FAPI_CONTEXT *context, char const *pathOfKeyToDuplicate, char const *pathToPublicKeyOfNewParent, char **exportedData)
TSS2_RC | Fapi_ExportKey_Async (FAPI_CONTEXT *context, char const *pathOfKeyToDuplicate, char const *pathToPublicKeyOfNewParent)
TSS2_RC | Fapi_ExportKey_Finish (FAPI_CONTEXT *context, char **exportedData)

## Detailed Description

FAPI functions to invoke ExportKey either as one-call or in an asynchronous manner.

## Function Documentation

## Fapi_ExportKey()

TSS2_RC Fapi_ExportKey | ( | FAPI_CONTEXT * | context,
|  | char const * | pathOfKeyToDuplicate,
|  | char const * | pathToPublicKeyOfNewParent,
|  | char ** | exportedData )

One-Call function for Fapi_ExportKey

Given a key it will (if the key is a storage key) duplicate the key and package up the duplicated key and all keys below it into a file ready to move to a new TPM.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [in] | pathOfKeyToDuplicate | The path to the root of the subtree to export.
  [in] | pathToPublicKeyOfNewParent | The path to the public key of the new parent. May be NULL
  [out] | exportedData | The exported subtree

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context, pathOfKeyToDuplicate or exportedData is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if pathOfKeyToDuplicate or pathToPublicKeyOfNewParent does not map to a . FAPI object.
  TSS2_FAPI_RC_BAD_KEY | if the key at pathToPublicKeyOfNewParent is not suitable for the requeste operation.
  TSS2_FAPI_RC_KEY_NOT_DUPLICABLE | if the key is not a duplicable key.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_BAD_PATH | if a path is used in inappropriate context or contains illegal characters.
  TSS2_FAPI_RC_TRY_AGAIN | if an I/O operation is not finished yet and this function needs to be called again.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_AUTHORIZATION_UNKNOWN | if a required authorization callback is not set.
  TSS2_FAPI_RC_AUTHORIZATION_FAILED | if the authorization attempt fails.
  TSS2_FAPI_RC_POLICY_UNKNOWN | if policy search for a certain policy digest was not successful.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.

## Fapi_ExportKey_Async()

TSS2_RC Fapi_ExportKey_Async | ( | FAPI_CONTEXT * | context,
|  | char const * | pathOfKeyToDuplicate,
|  | char const * | pathToPublicKeyOfNewParent )

Asynchronous function for Fapi_ExportKey

Given a key it will (if the key is a storage key) duplicate the key and package up the duplicated key and all keys below it into a file ready to move to a new TPM.

Call Fapi_ExportKey_Finish to finish the execution of this command.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [in] | pathOfKeyToDuplicate | The path to the root of the subtree to export.
  [in] | pathToPublicKeyOfNewParent | The path to the public key of the new parent

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context or pathOfKeyToDuplicate is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if pathOfKeyToDuplicate or pathToPublicKeyOfNewParent does not map to a . FAPI object.
  TSS2_FAPI_RC_BAD_KEY | if the key at pathToPublicKeyOfNewParent is not suitable for the requeste operation.
  TSS2_FAPI_RC_KEY_NOT_DUPLICABLE | if the key is not a duplicable key.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.

## Fapi_ExportKey_Finish()

TSS2_RC Fapi_ExportKey_Finish | ( | FAPI_CONTEXT * | context,
|  | char ** | exportedData )

Asynchronous finish function for Fapi_ExportKey

This function should be called after a previous Fapi_ExportKey_Async.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [out] | exportedData | The exported subtree

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context or exportedData is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_TRY_AGAIN | if the asynchronous operation is not yet complete. Call this function again later.
  TSS2_FAPI_RC_BAD_PATH | if a path is used in inappropriate context or contains illegal characters.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if a key was not found.
  TSS2_FAPI_RC_AUTHORIZATION_UNKNOWN | if a required authorization callback is not set.
  TSS2_FAPI_RC_AUTHORIZATION_FAILED | if the authorization attempt fails.
  TSS2_FAPI_RC_POLICY_UNKNOWN | if policy search for a certain policy digest was not successful.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.